%# BEGIN BPS TAGGED BLOCK {{{
%#
%# COPYRIGHT:
%#
%# This software is Copyright (c) 1996-2023 Best Practical Solutions, LLC
%#                                          <sales@bestpractical.com>
%#
%# (Except where explicitly superseded by other copyright notices)
%#
%#
%# LICENSE:
%#
%# This work is made available to you under the terms of Version 2 of
%# the GNU General Public License. A copy of that license should have
%# been provided with this software, but in any event can be snarfed
%# from www.gnu.org.
%#
%# This work is distributed in the hope that it will be useful, but
%# WITHOUT ANY WARRANTY; without even the implied warranty of
%# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%# General Public License for more details.
%#
%# You should have received a copy of the GNU General Public License
%# along with this program; if not, write to the Free Software
%# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
%# 02110-1301 or visit their web page on the internet at
%# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html.
%#
%#
%# CONTRIBUTION SUBMISSION POLICY:
%#
%# (The following paragraph is not intended to limit the rights granted
%# to you to modify and distribute this software under the terms of
%# the GNU General Public License and is only of importance to you if
%# you choose to contribute your changes and enhancements to the
%# community by submitting them to Best Practical Solutions, LLC.)
%#
%# By intentionally submitting any modifications, corrections or
%# derivatives to this work, or any other work intended for use with
%# Request Tracker, to Best Practical Solutions, LLC, you confirm that
%# you are the copyright holder for those contributions and you grant
%# Best Practical Solutions,  LLC a nonexclusive, worldwide, irrevocable,
%# royalty-free, perpetual, license to use, copy, create derivative
%# works based on those contributions, and sublicense and distribute
%# those contributions and any derivatives thereof.
%#
%# END BPS TAGGED BLOCK }}}
<& /Elements/Header,
    Title => $title,
    onload => "function () { hide('Ticket-Create-details') }" &>
<& /Elements/Tabs &>
    
<& /Elements/ListActions, actions => \@results &>

<form action="<% RT->Config->Get('WebPath') %>/Ticket/Create.html" method="post" enctype="multipart/form-data" name="TicketCreate">
  <input type="submit" name="SubmitTicket" value="Create" style="display:none">
  <input type="hidden" class="hidden" name="id" value="new" />
  <input type="hidden" class="hidden" name="Token" value="<% $ARGS{'Token'} %>" />
  
% $m->callback( CallbackName => 'FormStart', QueueObj => $QueueObj, ARGSRef => \%ARGS );

% if ($gnupg_widget) {
  <& /Elements/Crypt/SignEncryptWidget:ShowIssues, self => $gnupg_widget, Queue => $QueueObj &>
% }

<div id="Ticket-Create-basics">
<a name="basics"></a>

<div id="ticket-create-metadata">
    <&| /Widgets/TitleBox, title => loc("Basics"), class=>'ticket-info-basics' &>
    <input type="hidden" class="hidden" name="Queue" value="<% $QueueObj->Id %>" />
    <table width="100%" border="0">
    <& /Ticket/Elements/EditBasics,
        InTable => 1,
        QueueObj => $QueueObj,
        defaults => \%ARGS,
        fields  => [
            {   name => 'Queue',
                comp => '/Ticket/Elements/ShowQueue',
                args => {
                    QueueObj => $QueueObj,
                },
            },
            {   name => 'Status',
                comp => '/Ticket/Elements/SelectStatus',
                args => {
                    Name            => "Status",
                    QueueObj        => $QueueObj,
                },
            },
            {   name => 'Owner',
                comp => '/Elements/SelectOwner',
                args => {
                    Name            => "Owner",
                    Default         => $ARGS{Owner} || RT->Nobody->Id,
                    DefaultValue    => 0,
                    QueueObj        => $QueueObj,
                },
            },

            { special => 'roles' },

            $QueueObj->SLADisabled ? () : (
            {   name => 'SLA',
                comp => '/Elements/SelectSLA',
                args => {
                    Name            => "SLA",
                    Default         => $ARGS{SLA} || RT::SLA->GetDefaultServiceLevel(Queue => $QueueObj),
                    DefaultValue    => RT::SLA->GetDefaultServiceLevel(Queue => $QueueObj) ? 0 : 1,
                    QueueObj        => $QueueObj,
                },
            }),
        ]
        &>

% $m->callback( CallbackName => 'AfterOwner', ARGSRef => \%ARGS );

      <& /Elements/EditCustomFields,
          %ARGS,
          Object => $ticket,
          CategoryObj => $QueueObj,
          CustomFields => $QueueObj->TicketCustomFields,
          Grouping => 'Basics',
          InTable => 1,
          ForCreation => 1,
      &>
      <& /Ticket/Elements/EditTransactionCustomFields, %ARGS, QueueObj => $QueueObj, InTable => 1 &>
    </table>
  </&>

<& /Ticket/Elements/ShowAssetsOnCreate, QueueObj => $QueueObj, ARGSRef => \%ARGS &>

% $m->callback( CallbackName => 'AfterBasics', QueueObj => $QueueObj, ARGSRef => \%ARGS );

<& /Elements/EditCustomFieldCustomGroupings,
    %ARGS,
    Object => $ticket,
    CategoryObj => $QueueObj,
    CustomFieldGenerator => sub { $QueueObj->TicketCustomFields },
    ForCreation => 1,
&>

</div>

<div id="ticket-create-message">
  <&| /Widgets/TitleBox, title => $title, class => 'messagedetails' &>
<table border="0" cellpadding="0" cellspacing="0">
% $m->callback(CallbackName => 'BeforeRequestors', QueueObj => $QueueObj, ARGSRef => \%ARGS);
<tr>
<td class="label">
<&|/l&>Requestors</&>:
</td>
<td class="value" colspan="5">
<& /Elements/EmailInput, Name => 'Requestors', Size => undef, Default => $ARGS{Requestors} // $session{CurrentUser}->EmailAddress, AutocompleteMultiple => 1, AutocompleteType => 'Principals' &>
% $m->callback( CallbackName => 'AfterRequestors', QueueObj => $QueueObj, ARGSRef => \%ARGS );
</td>
</tr>
<tr>
<td class="label">
<&|/l&>Cc</&>:
</td>
<td class="value" colspan="5"><& /Elements/EmailInput, Name => 'Cc', Size => undef, Default => $ARGS{Cc}, AutocompleteMultiple => 1, AutocompleteType => 'Principals' &></td>
</tr>

<tr>
  <td class="label">&nbsp;</td>
  <td class="comment" colspan="5">
    <i><font size="-2">
      <&|/l&>(Sends a carbon-copy of this update to a comma-delimited list of email addresses. These people <strong>will</strong> receive future updates.)</&>
    </font></i>
  </td>
</tr>

<tr>
<td class="label">
<&|/l&>Admin Cc</&>:
</td>
<td class="value" colspan="5"><& /Elements/EmailInput, Name => 'AdminCc', Size => undef, Default => $ARGS{AdminCc}, AutocompleteMultiple => 1, AutocompleteType => 'Principals' &></td>
</tr>

<tr>
  <td class="label">&nbsp;</td>
  <td class="comment" colspan="5">
    <i><font size="-2">
      <&|/l&>(Sends a carbon-copy of this update to a comma-delimited list of administrative email addresses. These people <strong>will</strong> receive future updates.)</&>
    </font></i>
  </td>
</tr>

% my $roles = $QueueObj->CustomRoles;
% $roles->LimitToMultipleValue;
% $m->callback( CallbackName => 'ModifyCustomRoles', ARGSRef => \%ARGS, CustomRoles => $roles );
% while (my $role = $roles->Next) {
<tr>
<td class="label">
<% $role->Name %>:
</td>
<td class="value" colspan="5"><& /Elements/MultiUserRoleInput, role => $role, Default => $ARGS{$role->GroupType} &></td>
</tr>

% if ($role->EntryHint) {
<tr>
  <td class="label">&nbsp;</td>
  <td class="comment" colspan="5">
    <i><font size="-2">
      <% $role->EntryHint %>
    </font></i>
  </td>
</tr>
% }
% }

<& /Elements/EditCustomFields,
    %ARGS,
    Object => $ticket,
    CategoryObj => $QueueObj,
    CustomFields => $QueueObj->TicketCustomFields,
    Grouping => 'People',
    InTable => 1,
    ForCreation => 1,
&>

<tr>
<td class="label">
<&|/l&>Subject</&>:
</td>
<td class="value" colspan="5">
<input type="text" name="Subject" maxsize="200" value="<%$ARGS{Subject} || ''%>" />
% $m->callback( %ARGS, CallbackName => 'AfterSubject' );
</td>
</tr>

% if ( $gnupg_widget ) {
<tr><td>&nbsp;</td><td colspan="5">
<& /Elements/Crypt/SignEncryptWidget, self => $gnupg_widget, QueueObj => $QueueObj &>
</td></tr>
% }

<tr>
<td colspan="6">
<&|/l&>Describe the issue below</&>:<br />
% if ( RT->Config->Get('ArticleOnTicketCreate')) {
<& /Articles/Elements/BeforeMessageBox, %ARGS, QueueObj => $QueueObj &>
% }
% $m->callback( %ARGS, QueueObj => $QueueObj, CallbackName => 'BeforeMessageBox' );
% if (exists $ARGS{Content}) {
<& /Elements/MessageBox, Default => $ARGS{Content}, IncludeSignature => 0 &>
% } else {
<& /Elements/MessageBox, QuoteTransaction => $QuoteTransaction &>
%}
% $m->callback( %ARGS, QueueObj => $QueueObj, CallbackName => 'AfterMessageBox' );

<br />
</td>
</tr>

        <& /Ticket/Elements/AddAttachments, %ARGS, QueueObj => $QueueObj &>
      </table>
    </&>
    <& /Elements/Submit, Label => loc("Create"), id => 'SubmitTicket' &>
  </div>
</div>

<div id="Ticket-Create-details">
<a name="details"></a>
<table width="100%" border="0">
<tr>
<td width="50%" valign="top" class="boxcontainer">
    <div class="ticket-info-basics">
          <&| /Widgets/TitleBox, title => loc('The Basics'), 
                title_class=> 'inverse',  
                color => "#993333" &>
<table border="0">
<tr><td class="label"><&|/l&>Priority</&>:</td>
<td><& /Elements/SelectPriority,
    Name => "InitialPriority",
    Default => $ARGS{InitialPriority} ? $ARGS{InitialPriority} : $QueueObj->DefaultValue('InitialPriority'),
&></td></tr>
<tr><td class="label"><&|/l&>Final Priority</&>:</td>
<td><& /Elements/SelectPriority,
    Name => "FinalPriority",
    Default => $ARGS{FinalPriority} ? $ARGS{FinalPriority} : $QueueObj->DefaultValue('FinalPriority'),
&></td></tr>
<tr><td class="label"><&|/l&>Time Estimated</&>:</td>
<td>
<& /Elements/EditTimeValue, Name => 'TimeEstimated', Default => $ARGS{TimeEstimated} || '' &>

</td></tr>
<tr><td class="label"><&|/l&>Time Worked</&>:</td>
<td>
<& /Elements/EditTimeValue, Name => 'TimeWorked', Default => $ARGS{TimeWorked} || '' &>
</td></tr>
<tr>
<td class="label"><&|/l&>Time Left</&>:</td>
<td>
<& /Elements/EditTimeValue, Name => 'TimeLeft', Default => $ARGS{TimeLeft} || '' &>
</td></tr>
</table>
</&>
<br />
<div class="ticket-info-dates">
<&|/Widgets/TitleBox, title => loc("Dates"),
  title_class=> 'inverse',  
  color => "#663366" &>

<table>
<tr>
    <td class="label"><&|/l&>Starts</&>:</td>
    <td>
        <& /Elements/SelectDate,
            Name    => 'Starts',
            Default => $ARGS{Starts} || $QueueObj->DefaultValue('Starts') || '',
            Object  => $ticket,
            ARGSRef => \%ARGS,
        &>
    </td>
</tr>
<tr>
    <td class="label"><&|/l&>Due</&>:</td>
    <td>
        <& /Elements/SelectDate,
            Name    => 'Due',
            Default => $ARGS{Due} || $QueueObj->DefaultValue('Due') || '',
            Object  => $ticket,
            ARGSRef => \%ARGS,
        &>
    </td>
</tr>
<& /Elements/EditCustomFields,
    %ARGS,
    Object => $ticket,
    CategoryObj => $QueueObj,
    CustomFields => $QueueObj->TicketCustomFields,
    Grouping => 'Dates',
    InTable => 1,
    ForCreation => 1,
&>
</table>
</&>
</div>
</div>
<br />
</td>

<td valign="top" class="boxcontainer">
<div class="ticket-info-links">
<&| /Widgets/TitleBox, title => loc('Links'), title_class=> 'inverse' &>
<& /Elements/AddLinks,
    Object          => $ticket,
    CustomFields    => $QueueObj->TicketCustomFields,
    ARGSRef         => \%ARGS,
    &>
</&>
</div>
<br />

</td>
</tr>
</table>
<& /Elements/Submit, Label => loc("Create") &>
</div>
</form>

<%INIT>
$m->callback( CallbackName => "Init", ARGSRef => \%ARGS );
my $Queue = $ARGS{Queue};
$session{DefaultQueue} = $Queue;

my $current_user = $session{'CurrentUser'};

if ($CloneTicket) {
    my $CloneTicketObj = RT::Ticket->new( $session{CurrentUser} );
    $CloneTicketObj->Load($CloneTicket)
        or Abort( loc("Ticket could not be loaded"), Code => HTTP::Status::HTTP_BAD_REQUEST );

    my $clone = {
        Requestors => join( ',', $CloneTicketObj->RequestorAddresses ),
        Cc         => join( ',', $CloneTicketObj->CcAddresses ),
        AdminCc    => join( ',', $CloneTicketObj->AdminCcAddresses ),
        InitialPriority => $CloneTicketObj->Priority,
    };

    $clone->{$_} = $CloneTicketObj->$_()
        for qw/Owner Subject FinalPriority Status/;

    $clone->{$_} = $CloneTicketObj->$_->AsString
        for grep { $CloneTicketObj->$_->IsSet }
        map      { $_ . "Obj" } qw/Starts Started Due Resolved/;

    my $get_link_value = sub {
        my ($link, $type) = @_;
        my $uri_method = $type . 'URI';
        my $local_method = 'Local' . $type;
        my $uri = $link->$uri_method;
        return if $uri->IsLocal and
                $uri->Object and
                $uri->Object->isa('RT::Ticket') and
                $uri->Object->__Value('Type') eq 'reminder';

        return $link->$local_method || $uri->URI;
    };
    my (@refers, @refers_by);
    my $refers = $CloneTicketObj->RefersTo;
    while ( my $refer = $refers->Next ) {
        my $refer_value = $get_link_value->($refer, 'Target');
        push @refers, $refer_value if defined $refer_value;
    }
    $clone->{'new-RefersTo'} = join ' ', @refers;

    my $refers_by = $CloneTicketObj->ReferredToBy;
    while ( my $refer_by = $refers_by->Next ) {
        my $refer_by_value = $get_link_value->($refer_by, 'Base');
        push @refers_by, $refer_by_value if defined $refer_by_value;
    }
    $clone->{'RefersTo-new'} = join ' ', @refers_by;

    my $cfs = $CloneTicketObj->QueueObj->TicketCustomFields();
    while ( my $cf = $cfs->Next ) {
        my $cf_id     = $cf->id;
        my $cf_values = $CloneTicketObj->CustomFieldValues( $cf->id );
        my @cf_values;
        while ( my $cf_value = $cf_values->Next ) {
            push @cf_values, $cf_value->Content;
        }

        next unless @cf_values;

        if ( @cf_values > 1 && $cf->Type eq 'Select' ) {
            $clone->{GetCustomFieldInputName( CustomField => $cf )} = \@cf_values;
        }
        else {
            if ( $cf->Type eq 'DateTime' ) {
                # Convert to user timezone. DateTime doesn't have multiple values, so only need to take care of
                # $cf_values[0]

                my $date = RT::Date->new( $session{'CurrentUser'} );
                $date->Set( Format => 'ISO', Value => $cf_values[0] );
                $cf_values[0] = $date->ISO( Timezone => 'user' );
            }

            $clone->{GetCustomFieldInputName( CustomField => $cf )} = join "\n",
              @cf_values;
        }
    }

    $m->callback( CallbackName => 'MassageCloneArgs', ARGSRef => $clone, Queue => $Queue );

    for ( keys %$clone ) {
        $ARGS{$_} = $clone->{$_} if not defined $ARGS{$_};
    }

}

my @results;

my $QueueObj = RT::Queue->new($current_user);
$QueueObj->Load($Queue) || Abort(loc("Queue [_1] could not be loaded.", $Queue||''), Code => HTTP::Status::HTTP_BAD_REQUEST);

my $title = loc("Create a new ticket in [_1]", $m->scomp("/Ticket/Elements/ShowQueue", QueueObj => $QueueObj, Escape => 0));

$m->callback( QueueObj => $QueueObj, title => \$title, results => \@results, ARGSRef => \%ARGS );

$m->scomp( '/Articles/Elements/SubjectOverride', ARGSRef => \%ARGS, QueueObj => $QueueObj, results => \@results );

$QueueObj->Disabled && Abort(loc("Cannot create tickets in a disabled queue."), Code => HTTP::Status::HTTP_NOT_FOUND);

my $ticket = RT::Ticket->new($current_user); # empty ticket object

ProcessAttachments(ARGSRef => \%ARGS);

my $checks_failure = 0;

{
    my ($status, @msg) = $m->comp(
        '/Elements/ValidateCustomFields',
        CustomFields    => $QueueObj->TicketCustomFields,
        ARGSRef         => \%ARGS
    );
    unless ($status) {
        $checks_failure = 1;
        push @results, @msg;
    }

    ( $status, @msg ) = PreprocessTimeUpdates( \%ARGS );
    unless ( $status ) {
        push @results, @msg;
        $checks_failure = 1;
    }
}

my $gnupg_widget = $m->comp('/Elements/Crypt/SignEncryptWidget:new', Arguments => \%ARGS );
$m->comp( '/Elements/Crypt/SignEncryptWidget:Process',
    self      => $gnupg_widget,
    QueueObj  => $QueueObj,
);


if ( !exists $ARGS{'AddMoreAttach'} && ($ARGS{'id'}||'') eq 'new' ) {
    my $status = $m->comp('/Elements/Crypt/SignEncryptWidget:Check',
        self      => $gnupg_widget,
        Operation => 'Create',
        QueueObj  => $QueueObj,
    );
    $checks_failure = 1 unless $status;
}

# check email addresses for RT's
{
    my $custom_roles = $QueueObj->CustomRoles;
    my @static_roles = qw(Requestors Cc AdminCc);
    while (my $role = shift @static_roles || $custom_roles->Next) {
        my $field = ref $role ? $role->GroupType : $role;
        my $value = $ARGS{ $field };
        next unless defined $value && length $value;

        my @emails;
        my @list = RT::EmailParser->_ParseEmailAddress( $value );
        foreach my $entry ( @list ) {
            if ( $entry->{type} eq 'mailbox' ) {
                my $email = $entry->{value};
                if ( RT::EmailParser->IsRTAddress($email->address) ) {
                    # No need to localize custom roles, to be consistent with labels
                    push @results, loc("[_1] is an address RT receives mail at. Adding it as a '[_2]' would create a mail loop", $email->format, ref $role ? $role->Name : loc($role =~ /^(.*?)s?$/) );
                    $checks_failure ||= 1;
                }
                else {
                    push @emails, $email->format;
                }
            }
            else {
                push @emails, $entry->{value};
            }
        }
        $ARGS{ $field } = join ', ', grep defined, @emails;
    }
}

my $skip_create = 0;
$m->callback( CallbackName => 'BeforeCreate', ARGSRef => \%ARGS, skip_create => \$skip_create, 
              checks_failure => $checks_failure, results => \@results );

$m->comp( '/Articles/Elements/CheckSkipCreate', ARGSRef => \%ARGS, skip_create => \$skip_create,
              checks_failure => $checks_failure, results => \@results );

if ((!exists $ARGS{'AddMoreAttach'}) and (!exists $ARGS{'Go'}) and (defined($ARGS{'id'}) and $ARGS{'id'} eq 'new')) { # new ticket?
    if ( !$checks_failure && !$skip_create ) {
        $m->comp('Display.html', %ARGS);
        $RT::Logger->crit("After display call; error is $@");
        $m->abort();
    }
}
PageMenu->child( basics => raw_html =>  q[<a href="#basics" onclick="return switchVisibility('Ticket-Create-basics','Ticket-Create-details');">] . loc('Basics') . q[</a>]);
PageMenu->child( details => raw_html =>  q[<a href="#details" onclick="return switchVisibility('Ticket-Create-details','Ticket-Create-basics');">] . loc('Details') . q[</a>]);
</%INIT>

<%ARGS>
$DependsOn => undef
$DependedOnBy => undef
$MemberOf => undef
$QuoteTransaction => undef
$CloneTicket => undef
</%ARGS>
